/*
 * copyright (c)2009 http://wamsoft.jp
 * zlib license
 */
#ifndef __SQOBJECT_H__
#define __SQOBJECT_H__

// ^
#ifndef SQOBJECT
#define SQOBJECT Object
#define SQOBJECTNAME _SC("Object")
#endif

#include "sqobjectinfo.h"

namespace sqobject {

const SQChar *getString(HSQUIRRELVM v, SQInteger idx);

/**
 * IuWFNgp
 */
class Object {

protected:
	// squirrelIuWFNg̎ȎQ
	ObjectInfo self;
	// ̃IuWFNg҂ĂXbḧꗗ
	ObjectInfo _waitThreadList;
	// delegate
	ObjectInfo delegate;

public:
#ifdef SQOBJHEAP
	SQHEAPDEFINE;
#endif
	bool isInit() {
		return !self.isNull();
	}
	void push(HSQUIRRELVM v) {
		self.push(v);
	}
	
	/**
	 * IuWFNg҂̓o^
	 * @param thread Xbh
	 */
	void addWait(ObjectInfo &thread);
	
	/**
	 * IuWFNg҂̉
	 * @param thread Xbh
	 */
	void removeWait(ObjectInfo &thread);
	
	/**
	 * RXgN^
	 */
	Object();
	
	/**
	 * RXgN^
	 * @param v squirrelVM
	 * @param delegateIdx fQ[gi[Ăԍ
	 */
	Object(HSQUIRRELVM v, int delegateIdx=2);

	/**
	 * fXgN^
	 */
	virtual ~Object();

	/**
	 * ȎQƏp
	 * ftHgRXgN^ŏꍇ͕K̏Ԃ
	 * @param v SQUIRREL vm
	 * @param idx ̃IuWFNgCfbNX
	 */
	void initSelf(HSQUIRRELVM v, int idx=1);

	/**
	 * jp
	 */
	void destructor();

public:
	
	// ------------------------------------------------------------------

	/**
	 * ̃IuWFNg҂ĂPXbh̑҂
	 */
	void notify();
	
	/**
	 * ̃IuWFNg҂ĂSXbh̑҂
	 */
	void notifyAll();
	
	/**
	 * vpeBl擾
	 * @param name vpeB
	 * @return vpeBl
	 */
	SQRESULT _get(HSQUIRRELVM v);

	/**
	 * vpeBɒlݒ
	 * @param name vpeB
	 * @param value vpeBl
	 */
	SQRESULT _set(HSQUIRRELVM v);

	/**
	 * setvpeB̑݊mF
	 * @param name vpeB
	 * @return setvpeB݂ true
	 */
	SQRESULT hasSetProp(HSQUIRRELVM v);
	
	/**
	 * Ϗ̐ݒ
	 */
	SQRESULT setDelegate(HSQUIRRELVM v);

	/**
	 * Ϗ̎擾
	 */
	SQRESULT getDelegate(HSQUIRRELVM v);

public:
	/**
	 * squirrel NXo^
	 */
	static void registerClass();


protected:

	/**
	 * ȃIuWFNgCxgĂяoi)
	 * C++ squirrel ̎w胁\bhCxgƂăR[obNł܂B
	 * @param eventName Cxg
	 */
	SQRESULT callEvent(const SQChar *eventName) {
		return self.callMethod(eventName);
	}

	/**
	 * ȃIuWFNgCxgĂяoi1)
	 * @param eventName Cxg
	 * @param p1 
	 */
	template<typename T1> SQRESULT callEvent(const SQChar *eventName, T1 p1) {
		return self.callMethod(eventName, p1);
	}
	
	/**
	 * ȃIuWFNgCxgĂяoi2)
	 * @param eventName Cxg
	 * @param p1 
	 * @param p2 2
	 */
	template<typename T1, typename T2> SQRESULT callEvent(const SQChar *eventName, T1 p1, T2 p2) {
		return self.callMethod(eventName, p1, p2);
	}
	
	/**
	 * ԒlL莩ȃIuWFNgCxgĂяoi)
	 * @param r Al|C^
	 * @param eventName Cxg
	 */
	template<typename R> SQRESULT callEventResult(R* r, const SQChar *eventName) {
		return self.callMethodResult(r, eventName);
	}

	/**
	 * Ԓl莩ȃIuWFNgCxgĂяoi1)
	 * @param r Al|C^
	 * @param eventName Cxg
	 * @param p1 
	 */
	template<typename R, typename T1> SQRESULT callEventResult(R* r, const SQChar *eventName, T1 p1) {
		return self.callMethodResult(r, eventName, p1);
	}
	
	/**
	 * ԒlL莩ȃIuWFNgCxgĂяoi2)
	 * @param r Al|C^
	 * @param eventName Cxg
	 * @param p1 
	 * @param p2 2
	 */
	template<typename R, typename T1, typename T2> SQRESULT callEventResult(R* r, const SQChar *eventName, T1 p1, T2 p2) {
		return self.callMethodResult(r, eventName, p1, p2);
	}

};

};// namespace

// Oo͗p
#define SQPRINT(v,msg) {\
	SQPRINTFUNCTION print = sq_getprintfunc(v);\
	if (print) {\
		print(v,msg);\
	}\
}

#endif
